diff --git a/eos/private/pc_eos.f90 b/eos/private/pc_eos.f90
index 73031183..f9641a13 100644
--- a/eos/private/pc_eos.f90
+++ b/eos/private/pc_eos.f90
@@ -2399,61 +1794,64 @@
         W0XXX,W0XTT,W0XXT)
 !                                                       Version 19.01.10
 ! First part of BILN9: small CHI. Stems from BLIN9 v.24.12.08
-      type(auto_diff_real_2var_order1), intent(in) :: TEMP,CHI
-      type(auto_diff_real_2var_order1), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W0XXX,W0XTT,W0XXT
+      real(dp), intent(in) :: TEMP,CHI
+      real(dp), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
+      real(dp), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
+      real(dp), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
+      real(dp), intent(out) :: W0XXX,W0XTT,W0XXT
 
-      type(auto_diff_real_2var_order1) :: W,WDX,WDT,WDXX,WDTT,WDXT,WDXXX,WDXTT,WDXXT
-      type(auto_diff_real_2var_order1) :: ECHI, SQ, DN
+      real(dp) :: W,WDX,WDT,WDXX,WDTT,WDXT,WDXXX,WDXTT,WDXXT
+      real(dp) :: ECHI, SQ, DN
 
       integer :: I, J, K
-
-      ! The next three are really parameters but there isn't a clean way to initialize them
-      ! at declaration time. - Adam Jermyn 4/2/2020
-      real(dp) :: AC(5,0:2) ! read only after initialization
-      real(dp) :: AU(5,0:2) ! read only after initialization
-      real(dp) :: AA(5,0:2) ! read only after initialization
-
-      AC(1:5,0) = (/ &
-         0.37045057d0, .41258437d0, &
-           9.777982d-2, 5.3734153d-3, 3.8746281d-5/) ! c_i^0
-      AC(1:5,1) = (/ &
-           .39603109d0, .69468795d0,  &
-           .22322760d0, 1.5262934d-2, 1.3081939d-4/) ! c_i^1
-      AC(1:5,2) = (/ &
-           .76934619d0, 1.7891437d0,  &
-           .70754974d0, 5.6755672d-2, 5.5571480d-4/) ! c_i^2
-      AU(1:5,0) = (/ &
-         0.43139881d0, 1.7597537d0,  &
-           4.1044654d0, 7.7467038d0, 13.457678d0/) ! \chi_i^0
-      AU(1:5,1) = (/ &
-           .81763176d0, 2.4723339d0,  &
-           5.1160061d0, 9.0441465d0, 15.049882d0/) ! \chi_i^1
-      AU(1:5,2) = (/ &
-           1.2558461d0, 3.2070406d0,  &
-           6.1239082d0, 10.316126d0, 16.597079d0/) ! \chi_i^2
-
-     do J=0,2
+      real(dp), save :: AC(5,0:2) ! read only after initialization
+      real(dp), save :: AU(5,0:2) ! read only after initialization
+      real(dp), save :: AA(5,0:2) ! read only after initialization
+      integer, save :: KRUN=0 ! indicates need to initialize AA
+      logical, save :: initialized = .false.
+
+      if (.not. initialized) then
+         AC(1:5,0) = (/ &
+            0.37045057d0, .41258437d0, &
+              9.777982d-2, 5.3734153d-3, 3.8746281d-5/) ! c_i^0
+         AC(1:5,1) = (/ &
+              .39603109d0, .69468795d0,  &
+              .22322760d0, 1.5262934d-2, 1.3081939d-4/) ! c_i^1
+         AC(1:5,2) = (/ &
+              .76934619d0, 1.7891437d0,  &
+              .70754974d0, 5.6755672d-2, 5.5571480d-4/) ! c_i^2
+         AU(1:5,0) = (/ &
+            0.43139881d0, 1.7597537d0,  &
+              4.1044654d0, 7.7467038d0, 13.457678d0/) ! \chi_i^0
+         AU(1:5,1) = (/ &
+              .81763176d0, 2.4723339d0,  &
+              5.1160061d0, 9.0441465d0, 15.049882d0/) ! \chi_i^1
+         AU(1:5,2) = (/ &
+              1.2558461d0, 3.2070406d0,  &
+              6.1239082d0, 10.316126d0, 16.597079d0/) ! \chi_i^2
+         initialized = .true.
+      end if
+      if (KRUN.eq.0) then ! initialize
+        do J=0,2
         do I=1,5
            AA(I,J)=exp(-AU(I,J))
         enddo
-     enddo
-
+        enddo
+      endif
+      KRUN=KRUN+1
         do K=0,2
-           W=0.d0
-           WDX=0.d0
-           WDT=0.d0
-           WDXX=0.d0
-           WDTT=0.d0
-           WDXT=0.d0
-           WDXXX=0.d0
-           WDXTT=0.d0
-           WDXXT=0.d0
+           W=0.
+           WDX=0.
+           WDT=0.
+           WDXX=0.
+           WDTT=0.
+           WDXT=0.
+           WDXXX=0.
+           WDXTT=0.
+           WDXXT=0.
              ECHI=exp(-CHI)
             do I=1,5
-               SQ=sqrt(1.d0+AU(I,K)*TEMP/2.d0)
+               SQ=dsqrt(1.d0+AU(I,K)*TEMP/2.)
                DN=AA(I,K)+ECHI ! e^{-\chi_i}+e^{-\chi})
                W=W+AC(I,K)*SQ/DN
                WDX=WDX+AC(I,K)*SQ/(DN*DN)
@@ -2462,7 +1860,7 @@
                WDTT=WDTT-AC(I,K)*AU(I,K)*AU(I,K)/(DN*SQ*SQ*SQ)
                WDXT=WDXT+AC(I,K)*AU(I,K)/(SQ*DN*DN)
                WDXXX=WDXXX+AC(I,K)*SQ* &
-                 (ECHI*ECHI-4.d0*ECHI*AA(I,K)+AA(I,K)*AA(I,K))/(DN*DN*DN*DN)
+                 (ECHI*ECHI-4.*ECHI*AA(I,K)+AA(I,K)*AA(I,K))/(DN*DN*DN*DN)
                WDXTT=WDXTT-AC(I,K)*AU(I,K)*AU(I,K)/(DN*DN*SQ*SQ*SQ)
                WDXXT=WDXXT+AC(I,K)*AU(I,K)*(ECHI-AA(I,K))/(SQ*DN*DN*DN)
             enddo
@@ -2510,19 +1908,19 @@
         W0XXX,W0XTT,W0XXT)
 !                                                       Version 19.01.10
 ! Second part of BILN9: intermediate CHI. Stems from BLIN8 v.24.12.08
-      type(auto_diff_real_2var_order1), intent(in) :: TEMP
-      type(auto_diff_real_2var_order1) :: CHI ! can be modified, not sure if this is an intended side-effect
-      type(auto_diff_real_2var_order1), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W0XXX,W0XTT,W0XXT
-
-      type(auto_diff_real_2var_order1) :: W,WDX,WDT,WDXX,WDTT,WDXT,WDXXX,WDXTT,WDXXT
-      type(auto_diff_real_2var_order1) :: SQCHI, CE, ECHI, DE, D, XICHI, DXI
-      type(auto_diff_real_2var_order1) :: H, HX, HDX, HXX, HDXX, HT, HDT, HDTT
-      type(auto_diff_real_2var_order1) :: HTX, HDXT, HDXXT, HDXTT, HXXX, HDXXX
-      type(auto_diff_real_2var_order1) :: V, VX, VDX, VT, VDT, VXX, VDXX, VDXXX
-      type(auto_diff_real_2var_order1) :: VXXT, VDTT, VXT, VDXT, VDXXT, VDXTT
+      real(dp), intent(in) :: TEMP
+      real(dp) :: CHI ! can be modified, not sure if this is an intended side-effect
+      real(dp), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
+      real(dp), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
+      real(dp), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
+      real(dp), intent(out) :: W0XXX,W0XTT,W0XXT
+
+      real(dp) :: W,WDX,WDT,WDXX,WDTT,WDXT,WDXXX,WDXTT,WDXXT
+      real(dp) :: SQCHI, CE, ECHI, DE, D, XICHI, DXI
+      real(dp) :: H, HX, HDX, HXX, HDXX, HT, HDT, HDTT
+      real(dp) :: HTX, HDXT, HDXXT, HDXTT, HXXX, HDXXX
+      real(dp) :: V, VX, VDX, VT, VDT, VXX, VDXX, VDXXX
+      real(dp) :: VXXT, VDTT, VXT, VDXT, VDXXT, VDXTT
 
       integer :: I, J, K
       real(dp), parameter :: AX(5) = &
@@ -2550,13 +1948,13 @@
            WDXXX=0.d0
            WDXTT=0.d0
            WDXXT=0.d0
-             SQCHI=sqrt(CHI)
+             SQCHI=dsqrt(CHI)
             do I=1,5
                CE=AX(I)-1.d0
                ECHI=exp(CE*CHI)
                DE=1.d0+ECHI
-               D=1.d0+AX(I)*CHI*TEMP/2.d0
-               H=pow(CHI,K+1d0)*SQCHI*sqrt(D)/DE
+               D=1.d0+AX(I)*CHI*TEMP/2.
+               H=pow(CHI,K+1)*SQCHI*dsqrt(D)/DE
                HX=(K+1.5d0)/CHI+.25d0*AX(I)*TEMP/D-ECHI*CE/DE
                HDX=H*HX
                HXX=(K+1.5d0)/(CHI*CHI)+.125d0*pow2(AX(I)*TEMP/D)+ECHI*pow2(CE/DE)
@@ -2569,24 +1967,24 @@
                HDXXT=HDXX*HT+HDX*HT*HTX+HDXT*HTX &
                   + HDT*(.25d0*pow2(AX(I)*TEMP/D)-1.d0/(CHI*CHI))
                HDXTT=HDXT*HT-HDX*.125d0*pow2(AX(I)*CHI/D)+HDTT*HTX &
-                  + HDT*.5d0*AX(I)*(TEMP*.5d0*AX(I)*CHI/(D*D)-1.d0/D)
-               HXXX=(2d0*K+3d0)/pow3(CHI)+.125d0*pow3(AX(I)*TEMP/D) &
+                  + HDT*.5d0*AX(I)*(TEMP*.5d0*AX(I)*CHI/(D*D)-1./D)
+               HXXX=(2*K+3)/pow3(CHI)+.125d0*pow3(AX(I)*TEMP/D) &
                   - ECHI*(1.d0-ECHI)*pow3(CE/DE)
                HDXXX=HDXX*HX-2.d0*HDX*HXX+H*HXXX
                XICHI=AXI(I)+CHI
                DXI=1.d0+XICHI*TEMP/2.d0
-               V=pow(XICHI,1d0*K)*sqrt(XICHI*DXI)
+               V=pow(XICHI,K)*dsqrt(XICHI*DXI)
                VX=(K+.5d0)/XICHI+.25d0*TEMP/DXI
                VDX=V*VX
                VT=.25d0*XICHI/DXI
                VDT=V*VT
                VXX=(K+0.5d0)/(XICHI*XICHI)+.125d0*pow2(TEMP/DXI)
                VDXX=VDX*VX-V*VXX
-               VDXXX=VDXX*VX-2d0*VDX*VXX &
-                    + V*((2d0*K+1d0)/pow3(XICHI)+.125d0*pow3(TEMP/DXI))
-               VXXT=(1.d0-0.5d0*TEMP*XICHI/DXI)/DXI
+               VDXXX=VDXX*VX-2.*VDX*VXX &
+                    + V*((2*K+1)/pow3(XICHI)+.125d0*pow3(TEMP/DXI))
+               VXXT=(1.-0.5d0*TEMP*XICHI/DXI)/DXI
                VDTT=-V*VT*VT
-               VXT=1.d0/XICHI-0.5d0*TEMP/DXI
+               VXT=1./XICHI-0.5d0*TEMP/DXI
                VDXT=VDT*VXT+VDX*VT
                VDXXT=VDXT*VX+VDX*.25d0*VXXT-VDT*VXX-V*.25d0*TEMP/DXI*VXXT
                VDXTT=VDTT*VXT-VDT*0.5d0*VXXT+VDXT*VT &
@@ -2637,56 +2035,56 @@
         W0XXX,W0XTT,W0XXT)
 !                                                       Version 19.01.10
 ! Third part of BILN9: large CHI. Stems from BLIN8 v.24.12.08
-      type(auto_diff_real_2var_order1), intent(in) :: CHI, TEMP
-      ! type(auto_diff_real_2var_order1) :: CHI ! can be modified, not sure if this is an intended side-effect
-      type(auto_diff_real_2var_order1), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W0XXX,W0XTT,W0XXT
-
-      type(auto_diff_real_2var_order1), dimension(0:2) :: AM,AMDX,AMDT,AMDXX,AMDTT,AMDXT
-      type(auto_diff_real_2var_order1) :: CNU, CHINU, F, FDX, FDXX, FDXXX, C, D, DM
-      type(auto_diff_real_2var_order1) :: W, WDX, WDT, WDXX, WDXT, WDTT, WDXXX, WDXXT, WDXTT
-      type(auto_diff_real_2var_order1) :: R, RX, RDX, RDT, RXX, RDXX, RDTT, RXT, RDXT
-      type(auto_diff_real_2var_order1) :: RXXX, RDXXX, RXTT, RDXTT, RXXT, RDXXT
-      type(auto_diff_real_2var_order1) :: FMX1, FMX2, FMX, CKM
-      type(auto_diff_real_2var_order1) :: FMT1, FMT2, FMT, FMXX, FMXXX, FMTT
-      type(auto_diff_real_2var_order1) :: AMDXXX, FMT1DX, FMT2DX, FMXT, FMTTX
-      type(auto_diff_real_2var_order1) :: AMDXTT, FMX1DT, FMX2DT, FMXXT, AMDXXT
-      type(auto_diff_real_2var_order1) :: SQ2T, SQ2T3
-      type(auto_diff_real_2var_order1) :: A, ADX, ADT, ADXX, ADTT, ADXT, ADXTT, ADXXT
-      type(auto_diff_real_2var_order1) :: XT1, Aln, FJ0, ASQ3, ASQ3DX, BXT, BXXT
-      type(auto_diff_real_2var_order1) :: FJ0DX, FJ0DT, FJ0DXX, FJ0DTT, FJ0DXT
-      type(auto_diff_real_2var_order1) :: FJ0XXX, FJ0XXT, FJ0XTT
-      type(auto_diff_real_2var_order1) :: FJ1, FJ1DX, FJ1DT, FJ1DXX, FJ1DXT, FJ1DTT
-      type(auto_diff_real_2var_order1) :: FJ2, FJ2DX, FJ2DT, FJ2DXX, FJ2DXT, FJ2DTT
+      real(dp), intent(in) :: CHI, TEMP
+      ! real(dp) :: CHI ! can be modified, not sure if this is an intended side-effect
+      real(dp), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
+      real(dp), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
+      real(dp), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
+      real(dp), intent(out) :: W0XXX,W0XTT,W0XXT
+
+      real(dp), dimension(0:2) :: AM,AMDX,AMDT,AMDXX,AMDTT,AMDXT
+      real(dp) :: CNU, CHINU, F, FDX, FDXX, FDXXX, C, D, DM
+      real(dp) :: W, WDX, WDT, WDXX, WDXT, WDTT, WDXXX, WDXXT, WDXTT
+      real(dp) :: R, RX, RDX, RDT, RXX, RDXX, RDTT, RXT, RDXT
+      real(dp) :: RXXX, RDXXX, RXTT, RDXTT, RXXT, RDXXT
+      real(dp) :: FMX1, FMX2, FMX, CKM
+      real(dp) :: FMT1, FMT2, FMT, FMXX, FMXXX, FMTT
+      real(dp) :: AMDXXX, FMT1DX, FMT2DX, FMXT, FMTTX
+      real(dp) :: AMDXTT, FMX1DT, FMX2DT, FMXXT, AMDXXT
+      real(dp) :: SQ2T, SQ2T3
+      real(dp) :: A, ADX, ADT, ADXX, ADTT, ADXT, ADXTT, ADXXT
+      real(dp) :: XT1, Aln, FJ0, ASQ3, ASQ3DX, BXT, BXXT
+      real(dp) :: FJ0DX, FJ0DT, FJ0DXX, FJ0DTT, FJ0DXT
+      real(dp) :: FJ0XXX, FJ0XXT, FJ0XTT
+      real(dp) :: FJ1, FJ1DX, FJ1DT, FJ1DXX, FJ1DXT, FJ1DTT
+      real(dp) :: FJ2, FJ2DX, FJ2DT, FJ2DXX, FJ2DXT, FJ2DTT
       
       integer :: J, K
       real(dp), parameter :: PI26=PI*PI/6.
 
-      if (CHI*TEMP.lt..1d0) then
+      if (CHI*TEMP.lt..1) then
         do K=0,2
-           W=0.d0
-           WDX=0.d0
-           WDT=0.d0
-           WDXX=0.d0
-           WDTT=0.d0
-           WDXT=0.d0
-           WDXXX=0.d0
-           WDXTT=0.d0
-           WDXXT=0.d0
+           W=0.
+           WDX=0.
+           WDT=0.
+           WDXX=0.
+           WDTT=0.
+           WDXT=0.
+           WDXXX=0.
+           WDXTT=0.
+           WDXXT=0.
             do J=0,4 ! for nonrel.Fermi integrals from k+1/2 to k+4.5
                CNU=K+J+0.5d0 ! nonrelativistic Fermi integral index \nu
-               CHINU=pow(CHI,1d0*(K+J))*sqrt(CHI) ! \chi^\nu
-               F=CHINU*(CHI/(CNU+1.d0)+PI26*CNU/CHI & ! nonrel.Fermi
-                  + .7d0*PI26*PI26*CNU*(CNU-1.d0)*(CNU-2.d0)/pow3(CHI))
-               FDX=CHINU*(1d0+PI26*CNU*(CNU-1.d0)/pow2(CHI) &
-                  +.7d0*PI26*PI26*CNU*(CNU-1.d0)*(CNU-2.d0)*(CNU-3.d0)/pow4(CHI))
-               FDXX=CHINU/CHI*CNU*(1.d0+PI26*(CNU-1.d0)*(CNU-2.d0)/pow2(CHI) &
-                  +.7d0*PI26*PI26*(CNU-1.d0)*(CNU-2.d0)*(CNU-3.d0)*(CNU-4.d0)/pow4(CHI))
-               FDXXX=CHINU/pow2(CHI)*CNU*(CNU-1.d0)* &
-                  (1.d0+PI26*(CNU-2.d0)*(CNU-3.d0)/pow2(CHI) &
-                  +.7d0*PI26*PI26*(CNU-2.d0)*(CNU-3.d0)*(CNU-4.d0)*(CNU-5.d0)/pow4(CHI))
+               CHINU=pow(CHI,K+J)*dsqrt(CHI) ! \chi^\nu
+               F=CHINU*(CHI/(CNU+1.)+PI26*CNU/CHI & ! nonrel.Fermi
+                  + .7d0*PI26*PI26*CNU*(CNU-1.)*(CNU-2.)/pow3(CHI))
+               FDX=CHINU*(1.+PI26*CNU*(CNU-1.)/pow2(CHI) &
+                  +.7d0*PI26*PI26*CNU*(CNU-1.)*(CNU-2.)*(CNU-3.)/pow4(CHI))
+               FDXX=CHINU/CHI*CNU*(1.+PI26*(CNU-1.)*(CNU-2.)/pow2(CHI) &
+                  +.7d0*PI26*PI26*(CNU-1.)*(CNU-2.)*(CNU-3.)*(CNU-4.)/pow4(CHI))
+               FDXXX=CHINU/pow2(CHI)*CNU*(CNU-1.)* &
+                  (1.+PI26*(CNU-2.)*(CNU-3.)/pow2(CHI) &
+                  +.7d0*PI26*PI26*(CNU-2.)*(CNU-3.)*(CNU-4.)*(CNU-5.)/pow4(CHI))
               if (J.eq.0) then
                  W=F
                  WDX=FDX
@@ -2697,23 +2095,23 @@
                  W=W+C*F ! Fermi-Dirac, expressed through Fermi
                  WDX=WDX+C*FDX
                  WDXX=WDXX+C*FDXX
-                 WDT=F/4.d0
-                 WDXT=FDX/4.d0
-                 WDTT=0.d0
+                 WDT=F/4.
+                 WDXT=FDX/4.
+                 WDTT=0.
                  WDXXX=WDXXX+C*FDXXX
-                 WDXXT=FDXX/4.d0
-                 WDXTT=0.d0
+                 WDXXT=FDXX/4.
+                 WDXTT=0.
               else
-                 C=-C/(1d0*J)*(2d0*J-3d0)/4d0*TEMP
+                 C=-C/J*(2*J-3)/4.*TEMP
                  W=W+C*F
                  WDX=WDX+C*FDX
-                 WDT=WDT+C*(1d0*J)/TEMP*F
+                 WDT=WDT+C*J/TEMP*F
                  WDXX=WDXX+C*FDXX
-                 WDTT=WDTT+C*(1d0*J)*(1d0*(J-1))/pow2(TEMP)*F
-                 WDXT=WDXT+C*(1d0*J)/TEMP*FDX
+                 WDTT=WDTT+C*J*(J-1)/pow2(TEMP)*F
+                 WDXT=WDXT+C*J/TEMP*FDX
                  WDXXX=WDXXX+C*FDXXX
-                 WDXTT=WDXTT+C*(1d0*J)*(1d0*(J-1))/pow2(TEMP)*FDX
-                 WDXXT=WDXXT+C*(1d0*J)/TEMP*FDXX
+                 WDXTT=WDXTT+C*J*(J-1)/pow2(TEMP)*FDX
+                 WDXXT=WDXXT+C*J/TEMP*FDXX
               endif
             enddo ! next J
           if (K.eq.0) then
@@ -2745,7 +2143,7 @@
 !   ----------------------------------------------------------------   *
       else ! CHI > 14, CHI*TEMP > 0.1: general high-\chi expansion
          D=1.d0+CHI*TEMP/2.d0
-         R=sqrt(CHI*D)
+         R=dsqrt(CHI*D)
          RX=.5d0/CHI+.25d0*TEMP/D
          RDX=R*RX
          RDT=.25d0*pow2(CHI)/R
@@ -2762,8 +2160,8 @@
          RDXXT=RDXT*RX+RDX*RXT+RDT*RXX+R*RXXT
         do K=0,2
            DM=K+.5d0+(K+1.d0)*CHI*TEMP/2.d0
-           AM(K)=pow(CHI,1d0*K)*DM/R
-           FMX1=.5d0*(K+1.d0)*TEMP/DM
+           AM(K)=pow(CHI,K)*DM/R
+           FMX1=.5d0*(K+1.)*TEMP/DM
            FMX2=.25d0*TEMP/D
            FMX=(K-.5d0)/CHI+FMX1-FMX2
            AMDX(K)=AM(K)*FMX
@@ -2779,7 +2177,7 @@
            AMDXT(K)=AMDX(K)*FMT+AM(K)*(CKM*(1.d0-CKM*CHI*TEMP) &
               - .25d0/D+.125d0*CHI*TEMP/(D*D))
           if (K.eq.0) then
-             FMXXX=(2d0*K-1d0)/pow3(CHI)+2.d0*pow3(FMX1)-8.d0*pow3(FMX2)
+             FMXXX=(2*K-1)/pow3(CHI)+2.d0*pow3(FMX1)-8.d0*pow3(FMX2)
              AMDXXX=AMDXX(K)*FMX+2.d0*AMDX(K)*FMXX+AM(K)*FMXXX
              FMT1DX=CKM-TEMP*CHI*CKM*CKM
              FMT2DX=(.25d0-CHI*TEMP*.125d0/D)/D
@@ -2792,7 +2190,7 @@
              AMDXXT=AMDXT(K)*FMX+AMDX(K)*FMXT+AMDT(K)*FMXX+AM(K)*FMXXT
           endif
         enddo
-           SQ2T=sqrt(2.d0*TEMP)
+           SQ2T=dsqrt(2.d0*TEMP)
            SQ2T3=SQ2T*SQ2T*SQ2T
            A=1.d0+CHI*TEMP+SQ2T*R
            ADX=TEMP+SQ2T*RDX
@@ -2870,10 +2268,10 @@
 ! Input:  DENS - electron density [a.u.=6.7483346e24 cm^{-3}],
 ! TEMP - temperature [a.u.=2Ryd=3.1577e5 K]
 ! Output: CHI=\mu/TEMP, where \mu - electron chem.pot.w/o rest-energy
-      type(auto_diff_real_2var_order1), intent(in) :: DENS, TEMP
-      type(auto_diff_real_2var_order1), intent(out) :: CHI
+      real(dp), intent(in) :: DENS, TEMP
+      real(dp), intent(out) :: CHI
 
-      type(auto_diff_real_2var_order1) :: DENR,TEMR,CMU1,CMUDENR,CMUDT,CMUDTT
+      real(dp) :: DENR,TEMR,CMU1,CMUDENR,CMUDT,CMUDTT
       
       DENR=DENS/2.5733806d6 ! n_e in rel.un.=\lambda_{Compton}^{-3}
       TEMR=TEMP/1.8778865d4 ! T in rel.un.=(mc^2/k)=5.93e9 K
@@ -2884,8 +2282,7 @@
       subroutine CHEMFIT7(DENR,TEMR,CHI,CMU1,KDERIV, &
         CMUDENR,CMUDT,CMUDTT)
 !                                                       Version 28.05.07
-!                                                     corrected 08.08.11
-!                                               cosmetic change 16.05.13
+!                                                 "d0" inserted 23.03.09
 ! Fit to the chemical potential of free electron gas described in:
 !     G.Chabrier & A.Y.Potekhin, Phys.Rev.E 58, 4941 (1998)
 ! Stems from CHEMFIT v.10.10.96. The main difference - derivatives.
@@ -2897,18 +2294,18 @@
 !         CMUDT = (d\mu/dT)_V
 !         CMUDTT = (d^2\mu/dT^2)_V
 ! CMUDENR,CMUDT, and CMUDTT =0 on output, if KREDIV=0
-      type(auto_diff_real_2var_order1), intent(in) :: DENR,TEMR
+      real(dp), intent(in) :: DENR,TEMR
       integer, intent(in) :: KDERIV
-      type(auto_diff_real_2var_order1), intent(out) :: CHI,CMU1,CMUDENR,CMUDT,CMUDTT
-
-      type(auto_diff_real_2var_order1) :: PF0, TF, THETA, THETA32, Q2, T1, U3, THETAC, THETAG
-      type(auto_diff_real_2var_order1) :: D3, Q3, Q1, SQT, G, H, CT, F, X, XDF, XDFF
-      type(auto_diff_real_2var_order1) :: THETA52, CHIDY, CHIDYY
-      type(auto_diff_real_2var_order1) :: Q1D, Q1DD, Q2D, Q2DD, U3D, D3D, D3DD, Q3D, Q3DD
-      type(auto_diff_real_2var_order1) :: GDY, GDT, GDYY, GDTT, GDYT, GH
-      type(auto_diff_real_2var_order1) :: HDY, HDT, HDYY, HDTT, HDYT
-      type(auto_diff_real_2var_order1) :: CTY, CTT, CTDY, CTDT, CTDYY, CTDTT, CTDYT
-      type(auto_diff_real_2var_order1) :: CHIDT, CHIDTT, CHIDYT
+      real(dp), intent(out) :: CHI,CMU1,CMUDENR,CMUDT,CMUDTT
+
+      real(dp) :: PF0, TF, THETA, THETA32, Q2, T1, U3, THETAC, THETAG
+      real(dp) :: D3, Q3, Q1, SQT, G, H, CT, F, X, XDF, XDFF
+      real(dp) :: THETA52, CHIDY, CHIDYY
+      real(dp) :: Q1D, Q1DD, Q2D, Q2DD, U3D, D3D, D3DD, Q3D, Q3DD
+      real(dp) :: GDY, GDT, GDYY, GDTT, GDYT, GH
+      real(dp) :: HDY, HDT, HDYY, HDTT, HDYT
+      real(dp) :: CTY, CTT, CTDY, CTDT, CTDYY, CTDTT, CTDYT
+      real(dp) :: CHIDT, CHIDTT, CHIDYT
       
       real(dp), parameter :: PARA=1.612d0
       real(dp), parameter :: PARB=6.192d0
@@ -2918,12 +2315,12 @@
       
       PF0=pow(29.6088132d0*DENR,1d0/3d0) ! Classical Fermi momentum
       if (PF0.gt.1.d-4) then
-         TF=sqrt(1.d0+PF0*PF0)-1.d0 ! Fermi temperature
+         TF=dsqrt(1.d0+PF0*PF0)-1.d0 ! Fermi temperature
       else
          TF=.5d0*PF0*PF0
       endif
       THETA=TEMR/TF
-      THETA32=THETA*sqrt(THETA)
+      THETA32=THETA*dsqrt(THETA)
       Q2=12.d0+8.d0/THETA32
       T1=exp(-THETA) ! former ('96) 1/T
       U3=T1*T1+PARA
@@ -2936,19 +2333,19 @@
       else
          Q1=1.5d0/THETA
       endif
-      SQT=sqrt(TEMR)
+      SQT=dsqrt(TEMR)
       G=(1.d0+Q2*TEMR*Q3+Q1*SQT)*TEMR
       H=(1.d0+.5d0*TEMR/THETA)*(1.d0+Q2*TEMR)
       CT=1.d0+G/H
-      F=(2d0/3d0)/THETA32
+      F=.666666667d0/THETA32
       call FERINV7(F,1,X,XDF,XDFF)
       CHI=X & ! non-relativistic result
          - 1.5d0*log(CT) ! Relativistic fit
       CMU1=TEMR*CHI ! Fit to chemical potential w/o mc^2
       if (KDERIV.eq.0) then ! DISMISS DERIVATIVES
-         CMUDENR=0.d0
-         CMUDT=0.d0
-         CMUDTT=0.d0
+         CMUDENR=0.
+         CMUDT=0.
+         CMUDTT=0.
          return
       endif
 ! CALCULATE DERIVATIVES:
-- 
2.25.1

